unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ToolWin, ComCtrls, MD5;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    ToolBar1: TToolBar;
    Button1: TButton;
    Button2: TButton;
    ToolBar2: TToolBar;
    Edit1: TEdit;
    Button3: TButton;
    OpenDialog1: TOpenDialog;
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

function MD5String(S: string): string;
var
  ctx: MD5Context;
  digest: array[0..15]of Char;
  I: Integer;
begin
  // 񂩂lcT
  // ȉ̂R̊֐ MD5.pas jbgŎ
  MD5Init(ctx);
  MD5Update(ctx, PBYTE(PChar(S)), Length(S));
  MD5Final(ctx, digest);

  // PUi̕ɕϊ
  Result := '';
  for i := 0 to 15 do
    Result := Result +
      LowerCase(IntToHex(BYTE(digest[i]), 2));
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Memo1.Lines.Append('MD5 test suite:');
  Memo1.Lines.Append('MD5 ('''') = '+MD5String(''));
  Memo1.Lines.Append('MD5 (''a'') = '+
                  MD5String('a'));
  Memo1.Lines.Append('MD5 (''abc'') = '+
                  MD5String('abc'));
  Memo1.Lines.Append('MD5 (''message digest'') = '+
                  MD5String('message digest'));
  Memo1.Lines.Append('MD5 (''abcdefghijklmnopqrstuvwxyz'') = '+
                  MD5String('abcdefghijklmnopqrstuvwxyz'));
  Memo1.Lines.Append('MD5 (''ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789'') = '+
                  MD5String('ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789'));
  Memo1.Lines.Append('MD5 (''12345678901234567890123456789012345678901234567890123456789012345678901234567890'') = '+
                  MD5String('12345678901234567890123456789012345678901234567890123456789012345678901234567890'));
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  Memo1.Lines.Append('MD5 ('''+Edit1.Text+''') = '+
                  MD5String(Edit1.Text));
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  ctx: MD5Context;
  digest: array[0..15] of Char;
  buffer: array[0..1023] of Char;
  filestream: TFileStream;
  filename: String;
  readsize: Integer;
  count: Integer;
  Result: String;
begin
  if OpenDialog1.Execute
    then
      begin
        filename:=OpenDialog1.FileName;
        Memo1.Lines.Append( filename );
        filestream:=TFileStream.Create(filename , fmOpenRead or fmShareDenyWrite);
        try
          if Assigned(filestream)
            then
              begin
                filestream.Position:= 0;
                MD5Init(ctx);
                while TRUE do
                begin
                  readsize := filestream.Read(buffer, SizeOf(buffer));
                  if readsize = 0 then break;
                  MD5Update(ctx, @buffer, readsize);
                end;
                MD5Final(ctx, digest);
                Result := '';
                
                for count := 0 to 15 do
                  Result := Result +
                  LowerCase(IntToHex(BYTE(digest[count]), 2));

                Memo1.Lines.Append(Result);
              end;
        finally
          filestream.Free;
        end;
    end;
end;

end.
